unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, wcrypt2;

type
  TMainForm = class(TForm)
    ContainerEdit: TEdit;
    Label1: TLabel;
    ActionRadioGroup: TRadioGroup;
    AlgRadioGroup: TRadioGroup;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    procedure ActionRadioGroupClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.ActionRadioGroupClick(Sender: TObject);
begin
AlgRadioGroup.Enabled := (ActionRadioGroup.ItemIndex = 0);
end;

function ErrToStr(e: int64): string;
begin
case e of
ERROR_BUSY: ErrToStr := 'ERROR_BUSY';
ERROR_CALL_NOT_IMPLEMENTED: ErrToStr := 'ERROR_CALL_NOT_IMPLEMENTED';
ERROR_INVALID_HANDLE: ErrToStr := 'ERROR_INVALID_HANDLE';
ERROR_INVALID_PARAMETER: ErrToStr := 'ERROR_INVALID_PARAMETER';
ERROR_MORE_DATA: ErrToStr := 'ERROR_MORE_DATA';
ERROR_NO_MORE_ITEMS: ErrToStr := 'ERROR_NO_MORE_ITEMS';
ERROR_NOT_ENOUGH_MEMORY: ErrToStr := 'ERROR_NOT_ENOUGH_MEMORY';
NTE_BAD_ALGID: ErrToStr := 'NTE_BAD_ALGID';
NTE_BAD_DATA: ErrToStr := 'NTE_BAD_DATA';
NTE_BAD_FLAGS: ErrToStr := 'NTE_BAD_FLAGS';
NTE_BAD_HASH: ErrToStr := 'NTE_BAD_HASH';
NTE_BAD_HASH_STATE: ErrToStr := 'NTE_BAD_HASH_STATE';
NTE_BAD_KEY: ErrToStr := 'NTE_BAD_KEY';
NTE_BAD_KEYSET: ErrToStr := 'NTE_BAD_KEYSET';
NTE_BAD_KEYSET_PARAM: ErrToStr := 'NTE_BAD_KEYSET_PARAM';
NTE_BAD_LEN: ErrToStr := 'NTE_BAD_LEN';
NTE_BAD_PROV_TYPE: ErrToStr := 'NTE_BAD_PROV_TYPE';
NTE_BAD_PUBLIC_KEY: ErrToStr := 'NTE_BAD_PUBLIC_KEY';
NTE_BAD_SIGNATURE: ErrToStr := 'NTE_BAD_SIGNATURE';
NTE_BAD_TYPE: ErrToStr := 'NTE_BAD_TYPE';
NTE_BAD_UID: ErrToStr := 'NTE_BAD_UID';
NTE_DOUBLE_ENCRYPT: ErrToStr := 'NTE_DOUBLE_ENCRYPT';
NTE_EXISTS: ErrToStr := 'NTE_EXISTS';
NTE_FAIL: ErrToStr := 'NTE_FAIL';
NTE_KEYSET_ENTRY_BAD: ErrToStr := 'NTE_KEYSET_ENTRY_BAD';
NTE_KEYSET_NOT_DEF: ErrToStr := 'NTE_KEYSET_NOT_DEF';
NTE_NO_KEY: ErrToStr := 'NTE_NO_KEY';
NTE_NO_MEMORY: ErrToStr := 'NTE_NO_MEMORY';
NTE_PROV_DLL_NOT_FOUND: ErrToStr := 'NTE_PROV_DLL_NOT_FOUND';
NTE_PROV_TYPE_ENTRY_BAD: ErrToStr := 'NTE_PROV_TYPE_ENTRY_BAD';
NTE_PROV_TYPE_NO_MATCH: ErrToStr := 'NTE_PROV_TYPE_NO_MATCH';
NTE_PROV_TYPE_NOT_DEF: ErrToStr := 'NTE_PROV_TYPE_NOT_DEF';
NTE_PROVIDER_DLL_FAIL: ErrToStr := 'NTE_PROVIDER_DLL_FAIL';
NTE_SIGNATURE_FILE_BAD: ErrToStr := 'NTE_SIGNATURE_FILE_BAD';
//: ErrToStr := '';
else ErrToStr := 'unknown error';
end;
end;

procedure TMainForm.BitBtn2Click(Sender: TObject);
begin
Close;
end;

procedure TMainForm.BitBtn1Click(Sender: TObject);
var cont: PChar;
    err: string;
    hProv: HCRYPTPROV;
    KeyExchKey, SessionKey: HCRYPTKEY;
    flag, keyLen: DWORD;
    infile, outfile: file;
    tmp: PBYTE;
    buf: array [0..511] of byte;
    alg: ALG_ID;
    stream: boolean;
begin
if length(ContainerEdit.Text) = 0
then cont := nil
else
    begin
    err := ContainerEdit.Text;
    cont := StrAlloc(length(err) + 1);
    StrPCopy(cont, err);
    end;
if not CryptAcquireContext(@hProv, cont, nil, PROV_RSA_FULL, 0)
then
    begin
    MessageDlg('Error of containger opening: ' + ErrToStr(GetLastError),
                       mtError, [mbOK], 0);
    exit;
    end;
if ActionRadioGroup.ItemIndex = 0
then
    begin
    OpenDlg.Title := '   ';
    if OpenDlg.Execute then AssignFile(infile, OpenDlg.FileName)
    else exit;
    OpenDlg.Title := '       ';
    if OpenDlg.Execute then
       begin
       AssignFile(outfile, OpenDlg.FileName);
       reset(outfile, 1);
       keyLen := FileSize(outfile);
       GetMem(tmp, keyLen);
       BlockRead(outfile, tmp^, keyLen);
       CloseFile(outfile);
       end
    else exit;
    if not CryptImportKey(hProv, tmp, keyLen, 0, 0, @KeyExchKey) then
       begin
       MessageDlg('  : ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
       exit;
       end;
    FreeMem(tmp, keyLen);
    SaveDlg.Title := '     ';
    if SaveDlg.Execute then AssignFile(outfile, SaveDlg.FileName)
    else exit;
    rewrite(outfile, 1);
    case AlgRadioGroup.ItemIndex of
    0: begin
       alg := CALG_RC2;
       stream := false;
       end;
    1: begin
       alg := CALG_RC4;
       stream := true;
       end;
    else exit;
    end;
    if not CryptGenKey(hProv, alg, CRYPT_EXPORTABLE or CRYPT_CREATE_SALT,
                              @SessionKey) then
       begin
       MessageDlg('  : ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
       exit;
       end;
    keyLen := 128;
    GetMem(tmp, keyLen);
    if not CryptExportKey(SessionKey, KeyExchKey, SIMPLEBLOB, 0, tmp, @keyLen) then
       begin
       MessageDlg('  : ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
       exit;
       end;
    BlockWrite(outfile, keyLen, 4);
    BlockWrite(outfile, tmp^, keyLen);
    if not CryptDestroyKey(KeyExchKey) then
       begin
       MessageDlg('    : ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
       exit;
       end;
    keyLen := 512;
    if not CryptGetKeyParam(SessionKey, KP_SALT, @buf, @keyLen, 0) then
       begin
       MessageDlg('  salt-: ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
       exit;
       end;
    BlockWrite(outfile, keyLen, 4); // salt-
    BlockWrite(outfile, buf, keyLen); //salt-
    if not stream then
       begin
       // IV
       keyLen := 512;
       if not CryptGetKeyParam(SessionKey, KP_IV, @buf, @keyLen, 0) then
          begin
          MessageDlg('Error of IV getting: ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
          exit;
          end;
       if not CryptGenRandom(hProv, keyLen, @buf) then
          begin
          MessageDlg('  IV: ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
          exit;
          end;
       if not CryptSetKeyParam(SessionKey, KP_IV, @buf, 0) then
          begin
          MessageDlg('  IV: ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
          exit;
          end;
       BlockWrite(outfile, keyLen, 4);
       BlockWrite(outfile, buf, keyLen);
       end;
    reset(infile, 1);
    while not eof(infile) do
          begin
          BlockRead(infile, buf, 496, keyLen);
          if not CryptEncrypt(SessionKey, 0, eof(infile), 0, @buf, @keyLen, 512) then
             begin
             MessageDlg('  : ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
             exit;
             end;
          BlockWrite(outfile, buf, keyLen);
          end;
    CloseFile(infile);
    CloseFile(outfile);
    if not CryptDestroyKey(SessionKey) then
       MessageDlg('   : ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
    end
else
    begin
    if not CryptGetUserKey(hProv, AT_KEYEXCHANGE, @KeyExchKey) then
       begin
       MessageDlg('    : ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
       exit;
       end;
    OpenDlg.Title := '    ';
    if OpenDlg.Execute then AssignFile(infile, OpenDlg.FileName)
    else exit;
    reset(infile, 1);
    BlockRead(infile, keyLen, 4);
    GetMem(tmp, keyLen);
    BlockRead(infile, tmp^, keyLen);
    if not CryptImportKey(hProv, tmp, keyLen, KeyExchKey, 0, @SessionKey) then
       begin
       MessageDlg('   : ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
       exit;
       end;
    FreeMem(tmp, keyLen);
    if not CryptDestroyKey(KeyExchKey) then
       begin
       MessageDlg('     : ' +
                          ErrToStr(GetLastError), mtError, [mbOK], 0);
       exit;
       end;
    BlockRead(infile, keyLen, 4);
    BlockRead(infile, buf, keyLen); //salt
    if not CryptSetKeyParam(SessionKey, KP_SALT, @buf, 0) then
       begin
       MessageDlg('  salt-: ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
       exit;
       end;
    keyLen := 4;
    if not CryptGetKeyParam(SessionKey, KP_ALGID, @alg, @keyLen, 0) then
       begin
       MessageDlg('    : ' +
                          ErrToStr(GetLastError), mtError, [mbOK], 0);
       exit;
       end;
    case alg of
    CALG_RC2: stream := false;
    CALG_RC4: stream := true;
    end;
    if not stream then
       begin
       // IV
       BlockRead(infile, keyLen, 4);
       BlockRead(infile, buf, keyLen);
       if not CryptSetKeyParam(SessionKey, KP_IV, @buf, 0) then
          begin
          MessageDlg('  IV: ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
          exit;
          end;
       end;
    SaveDlg.Title := '     ';
    if SaveDlg.Execute then
       begin
       AssignFile(outfile, SaveDlg.FileName);
       rewrite(outfile, 1);
       while not eof(infile) do
             begin
             BlockRead(infile, buf, 512, keyLen);
             if not CryptDecrypt(SessionKey, 0, eof(infile), 0, @buf, @keyLen) then
                begin
                MessageDlg('Error of decrypting: ' + ErrToStr(GetLastError),
                                   mtError, [mbOK], 0);
                exit;
                end;
             BlockWrite(outfile, buf, keyLen);
             end;
       CloseFile(outfile);
       end;
    CloseFile(infile);
    if not CryptDestroyKey(SessionKey) then
       MessageDlg('   : ' + ErrToStr(GetLastError),
                          mtError, [mbOK], 0);
    end;
if not CryptReleaseContext(hProv, 0) then
   MessageDlg('  : ' + ErrToStr(GetLastError),
                      mtError, [mbOK], 0);
end;

end.
